/*
 * int21.c
 */

#include <7080S.H>
#include "libmemes.h"

#define USE_INT

#define	printf	((int (*)(const char *,...))0x00007c7c)

#define	SW6 	(PD.DR.BIT.B18)
#define	SW5 	(PD.DR.BIT.B17)
#define	SW4 	(PD.DR.BIT.B16)

#define	LED6	(PE.DR.BIT.B11)
#define	LED5	(PE.DR.BIT.B9)
#define	LED_ON	(0)
#define	LED_OFF	(1)

// ------------------------------------------------------------
// CMT0の割り込み処理関数
#pragma interrupt INT_CMT0_CMI0
void INT_CMT0_CMI0()
{
	CMT0.CMCSR.BIT.CMF = 0;		// 割り込み要求をクリア

	LED6 ^= 1;
}

// ------------------------------------------------------------
#ifdef USE_INT
// 割り込みを使用するときのメイン関数
void main()
{
	PFC.PEIORL.BIT.B11 = 1;		// PE11(LED6)端子を出力モードに設定

	STB.CR4.BIT._CMT = 0;		// CMTモジュールスタンバイの解除
	CMT0.CMCSR.BIT.CKS = 3;		// 1/512
	CMT0.CMCOR = 19531 - 1;		// 500ms
	CMT0.CMCSR.BIT.CMIE = 1;	// コンペアマッチ割り込み許可
	INTC.IPRJ.BIT._CMT0 = 8;	// 割り込み優先レベル = 8

	set_imask(7);			// マスクビット = 7

	printf("-- USE INT --\n");
	LED6 = LED_OFF;			// LED6初期状態
	CMT.CMSTR.BIT.STR0 = 1;		// CMT0スタート
	while (1)
		;
}

#else
// 割り込みを使用しないときのメイン関数
void main()
{
	PFC.PEIORL.BIT.B11 = 1;		// PE11(LED6)端子を出力モードに設定

	STB.CR4.BIT._CMT = 0;		// CMTモジュールスタンバイの解除
	CMT0.CMCSR.BIT.CKS = 3;		// 1/512
	CMT0.CMCOR = 19531 - 1;		// 500ms

	printf("-- not USE INT --\n");
	LED6 = LED_OFF;
	CMT.CMSTR.BIT.STR0 = 1;		// CMT0スタート
	while (1) {
		if (CMT0.CMCSR.BIT.CMF) {
			CMT0.CMCSR.BIT.CMF = 0;
			LED6 ^= 1;
		}
	}
}
#endif
