/*
 * int23.c
 */

#include <7080S.H>
#include "libmemes.h"

#define	printf	((int (*)(const char *,...))0x00007c7c)

#define	SW6 	(PD.DR.BIT.B18)
#define	SW5 	(PD.DR.BIT.B17)
#define	SW4 	(PD.DR.BIT.B16)

#define	LED6	(PE.DR.BIT.B11)
#define	LED5	(PE.DR.BIT.B9)
#define	LED_ON	(0)
#define	LED_OFF	(1)

#define	SPK		(PE.DR.BIT.B0)

#define	DIG1	(PE.DR.BIT.B3)
#define	DIG2	(PE.DR.BIT.B2)
#define	DIG3	(PE.DR.BIT.B1)


// ------------------------------------------------------------
// グローバル変数
int	num;


// ------------------------------------------------------------
// CMT0の割り込み処理関数
#pragma interrupt INT_CMT0_CMI0
void INT_CMT0_CMI0()
{
	static int keta;

	CMT0.CMCSR.BIT.CMF = 0;		// 割り込み要求をクリア

	if (++keta >= 3)
		keta = 0;

	DIG1 = DIG2 = DIG3 = 0;		// 全桁消灯
	PA.DR.BYTE.HL &= 0xf0;
	switch (keta) {
		case 0 :
			// 最下位桁
			PA.DR.BYTE.HL |= @@@@;
			DIG1 = 1;
			break;
		case 1 :
			PA.DR.BYTE.HL |= @@@@;
			DIG2 = 1;
			break;
		default :
			// 最上位桁
			PA.DR.BYTE.HL |= @@@@;
			DIG3 = 1;
			break;
	}
}


// ------------------------------------------------------------
void main()
{
	PFC.PEIORL.BIT.B11 = 1;		// PE11(LED6)端子を出力モードに設定
	PFC.PAIORH.BYTE.L |= 0x0f;	//
	PFC.PEIORL.BYTE.L |= 0x0e;	// DIG1〜DIG3を出力モードに設定

	STB.CR4.BIT._CMT = 0;		// CMTモジュールスタンバイの解除
	CMT0.CMCSR.BIT.CKS = 0;		// 1/8
	CMT0.CMCOR = @@@@@ - 1;		// 5ms
	CMT0.CMCSR.BIT.CMIE = 1;	// コンペアマッチ割り込み許可
	INTC.IPRJ.BIT._CMT0 = 8;	// 割り込み優先レベル = 8

	set_imask(7);			// マスクビット = 7

	num = 123;
	CMT.CMSTR.BIT.STR0 = 1;		// CMT0スタート
	while (1)
		;
}
